import bb.cascades 1.2
import "MyApps"

Page {
    titleBar: TitleBar {
        title: qsTr("About")
    }

    actions: [
        ReviewActionOnBarOrSignature {},
        ShareAction {}
    ]
    
    ScrollView {
        Container {
            topPadding: _ui.du(3)
            leftPadding: topPadding
            rightPadding: topPadding
            bottomPadding: topPadding
            layout: DockLayout {}
            horizontalAlignment: HorizontalAlignment.Fill
            verticalAlignment: VerticalAlignment.Fill
            Container {
                horizontalAlignment: HorizontalAlignment.Center
                verticalAlignment: VerticalAlignment.Center
                Label {
                    id: appNameLabel
                    horizontalAlignment: HorizontalAlignment.Center
                    text: Application.applicationName + " " + Application.applicationVersion
                    textStyle.base: SystemDefaults.TextStyles.BigText
                }
                Label {
                    property string emailUri: "mailto:roger@rogerleblanc.net?subject=" + appNameLabel.text + " support"
                    horizontalAlignment: HorizontalAlignment.Center
                    text: "<html><a href=\"" + emailUri + "\">" + qsTr("by CellNinja") + "</a></html>"
                    multiline: true
                    textStyle.base: SystemDefaults.TextStyles.TitleText
                }
                MyApps { topPadding: _ui.du(3) }
                Container {
                    topPadding: _ui.du(3)
                    horizontalAlignment: HorizontalAlignment.Center
                    Button {
                        text: "CellNinja BBM Channel"
                        imageSource: "asset:///images/ic_bbmchannel.png"
                        onClicked: { 
                            invokeChannel.query.invokeTargetId = "sys.bbm.channels.card.previewer"
                            invokeChannel.query.invokeActionId = "bb.action.OPENBBMCHANNEL"
                            invokeChannel.query.uri = "bbmc:C004E866D"
                            invokeChannel.query.updateQuery()
                        }
                        attachedObjects: [
                            Invocation {
                                id: invokeChannel
                                onArmed: { trigger(query.invokeActionId) }
                            }
                        ]
                    }
                }
                Container {
                    topPadding: _ui.du(3)
                    horizontalAlignment: HorizontalAlignment.Center
                    Button {
                        text: "Restart Tutorial"
                        onClicked: { tutorialSheet.open() }
                    }
                }
            }
        }
    }
}
