import bb.cascades 1.2
import bb.system 1.2

ActionItem {
    title: qsTr("Search")
    ActionBar.placement: ActionBarPlacement.OnBar
    imageSource: "asset:///images/ic_search.png"
    onTriggered: {
        systemPrompt.inputField.defaultText = fileContentTextArea.editor.selectedText
        systemPrompt.confirmButton.label = (fileContentTextArea.editor.selectedText != "") ? qsTr("Next Occurence") : qsTr("Search")
        systemPrompt.show()
        invisibleScrollView.hiddenTextAreaText = fileContentTextArea.text
    }
    attachedObjects: [
        SystemPrompt {
            id: systemPrompt
            title: qsTr("Search")
            body: qsTr("Type a keyword to search")
            includeRememberMe: false
            onFinished: {
                if (buttonSelection() == confirmButton) {
                    var textToLook = new String()
                    var offset = 0
                    
                    if (fileContentTextArea.editor.selectedText != "") {
                        textToLook = fileContentTextArea.text.substring(fileContentTextArea.editor.selectionEnd, fileContentTextArea.text.length)
                        offset = fileContentTextArea.editor.selectionEnd
                    }
                    else 
                        textToLook = fileContentTextArea.text
                        
                    var start = (textToLook.toLowerCase().indexOf(inputFieldTextEntry().toLowerCase()) + offset)
                    var end = start + inputFieldTextEntry().length
                    if (start >= offset) {
                        fileContentTextArea.editor.setSelection(start, end)
                        fileContentTextArea.editor.cursorPositionChanged(start)
                        fileContentTextArea.requestFocus()
//                        scrollView.scrollToPoint(0, (start / fileContentTextArea.text.length) * invisibleScrollView.scrollViewSize)
                    }
                    else {
                        fileContentTextArea.editor.setSelection(0, 0)
                        systemToast.body = "Can't find " + ((offset > 0) ? "next occurence of " : "") + inputFieldTextEntry()
                        systemToast.show()
                    }
                }
            }
        }
    ]
}
