/*
 * Copyright (c) 2011-2014 BlackBerry Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

import bb.cascades 1.2
import "Actions"

Page {
    id: fileContentPage
    
    property string completePath
    property bool isImage
    property alias fileName: titleBar.title
    property alias fileContent: fileContentTextArea.text
    
    onIsImageChanged: { 
        if (isImage)
            imageView.imageSource = "file:/" + completePath
    }        
        
    titleBar: TitleBar { id: titleBar }
    
    actions: [
        CopyActionOnBarOrSignature {},
        ShareFileAction {},
        SearchAction { enabled: !isImage }
    ]
    
    Container {
        layout: DockLayout {}
        InvisibleScrollView { id: invisibleScrollView }
        ScrollView {
            id: scrollView
            scrollRole: ScrollRole.Main
            Container {
                layout: DockLayout {}
                horizontalAlignment: HorizontalAlignment.Fill
                verticalAlignment: VerticalAlignment.Fill
                TextArea {
                    id: fileContentTextArea
                    editable: false
                    visible: (text != "")
                }
                ImageView {
                    id: imageView
                    visible: isImage
                    horizontalAlignment: HorizontalAlignment.Center
                    verticalAlignment: VerticalAlignment.Center
                }
            }
        }
    }
}
