import bb.cascades 1.2
import bb.system 1.0
import "DropDown"
import "Tutorial"

Page {
    titleBar: TitleBar {
        title: qsTr("Settings")
    }

    actions: [
        ReviewActionOnBarOrSignature {},
        ShareAction {}
    ]
    
    attachedObjects: [
        Invocation {
            id: settingsInvoke
            onArmed: {
                trigger(query.invokeActionId)
            }
        }
    ]

    Container {
        ScrollView {
            Container {
                id: mainContainer
                layout: DockLayout {}
                horizontalAlignment: HorizontalAlignment.Fill
                verticalAlignment: VerticalAlignment.Fill
                leftPadding: _ui.du(3)
                rightPadding: leftPadding
                
                property double numberOfDoubleTaps: 0
                
                gestureHandlers: [
                    DoubleTapHandler {
                        onDoubleTapped: {
                            mainContainer.numberOfDoubleTaps++
                            if (mainContainer.numberOfDoubleTaps == 2) {
                                mainContainer.numberOfDoubleTaps = 0
                                //                                _settings.setValue("sendToConsoleDebug", !_settings.value("sendToConsoleDebug", false))
                                //                                _app.setEnabled(_settings.value("sendToConsoleDebug", false))
                                //                                doubleTapToast.body = qsTr("ConsoleDebug mode set to ") + (_settings.value("sendToConsoleDebug", false) ? qsTr("ON") : qsTr("OFF"))
                                //                                doubleTapToast.show()
                            }
                        }
                        attachedObjects: [
                            SystemToast {
                                id: doubleTapToast
                            }
                        ]
                    },
                    LongPressHandler {
                        onLongPressed: {
                            navigationPane.isWritableShown = !navigationPane.isWritableShown
                            isWritableToast.body = qsTr("Writable files are now ") + (navigationPane.isWritableShown ? qsTr("marked with an *") : qsTr("aren't marked with an * anymore"))
                            isWritableToast.show()
                        }
                        attachedObjects: [
                            SystemToast {
                                id: isWritableToast
                                button.label: qsTr("Ok")
                            }
                        ]
                    }
                ]
                
                Container {
                    horizontalAlignment: HorizontalAlignment.Fill
                    verticalAlignment: VerticalAlignment.Fill
                    Header { title: qsTr("Visual") }
//                    IsUnreadableShownDropDown {topPadding: _ui.du(1) }
                    IsGridListLayoutDropDown { topPadding: _ui.du(1) }
                    ColumnCountDropDown { visible: navigationPane.isGridListLayout; topPadding: _ui.du(1) }
                    
                    Container { topPadding: _ui.du(1) }
                    
                    Header { title: qsTr("Tutorial") }
                    Container {
                        topPadding: _ui.du(1)
                        Button {
                            text: "Restart Tutorial"
                            onClicked: { tutorialSheet.open() }
                        }
                    }
                }
            }            
        }
    }
}         
